// *************************************************************************** mmx w/sse
// *************************************************************************** 
// *************************************************************************** 
// *************************************************************************** 


__m64 vec_sel64( __m64 a, __m64 b, __m64 mask ){

        b = _mm_and_si64( b, mask );
        a = _mm_andnot_si64( mask, a );

        return _mm_or_si64( a, b );
}


void SearchAP26_SSE(int K, int SHIFT, int START_ITER)
{
int64_t n, n43, n47, n53, n59;
int i43, i47, i53, i59;
int i3, i5, i31, i37, i41;

int j, jj;

int64_t STEP;
int64_t n0;

int64_t S31, S37, S41, S43, S47, S53, S59;

#if (REPORT_FREQUENCY==85 || REPORT_FREQUENCY==1355)
int iter = 0;
#endif

STEP=K*PRIM23;
n0=(N0*(K%17835)+((N0*17835)%MOD)*(K/17835)+N30)%MOD;

S31=(PRES2*(K%17835)+((PRES2*17835)%MOD)*(K/17835))%MOD;
S37=(PRES3*(K%17835)+((PRES3*17835)%MOD)*(K/17835))%MOD;
S41=(PRES4*(K%17835)+((PRES4*17835)%MOD)*(K/17835))%MOD;
S43=(PRES5*(K%17835)+((PRES5*17835)%MOD)*(K/17835))%MOD;
S47=(PRES6*(K%17835)+((PRES6*17835)%MOD)*(K/17835))%MOD;
S53=(PRES7*(K%17835)+((PRES7*17835)%MOD)*(K/17835))%MOD;
S59=(PRES8*(K%17835)+((PRES8*17835)%MOD)*(K/17835))%MOD;

//quick loop vectors

// MMX
short s61=S59%61;
short s67=S59%67;
short s71=S59%71;
short s73=S59%73;
short s79=S59%79;
short s83=S59%83;
short s89=S59%89;
short s97=S59%97;
short s101=S59%101;
short s103=S59%103;
short s107=S59%107;
short s109=S59%109;
short s113=S59%113;
short s127=S59%127;
short s131=S59%131;
short s137=S59%137;

__m64 mvec1		= _mm_set_pi16(MOD%61, MOD%67, MOD%71, MOD%73);
__m64 mvec2		= _mm_set_pi16(MOD%79, MOD%83, MOD%89, MOD%97);
__m64 mvec3		= _mm_set_pi16(MOD%101, MOD%103, MOD%107, MOD%109);
__m64 mvec4		= _mm_set_pi16(MOD%113, MOD%127, MOD%131, MOD%137);
__m64 svec1		= _mm_set_pi16(s61, s67, s71, s73);
__m64 svec2		= _mm_set_pi16(s79, s83, s89, s97);
__m64 svec3		= _mm_set_pi16(s101, s103, s107, s109);
__m64 svec4		= _mm_set_pi16(s113, s127, s131, s137);

__m64 numvec1_1	= _mm_set_pi16(61, 67, 71, 73);
__m64 numvec2_1	= _mm_set_pi16(60, 66, 70, 72);

__m64 numvec1_2	= _mm_set_pi16(79, 83, 89, 97);
__m64 numvec2_2	= _mm_set_pi16(78, 82, 88, 96);

__m64 numvec1_3	= _mm_set_pi16(101, 103, 107, 109);
__m64 numvec2_3	= _mm_set_pi16(100, 102, 106, 108);

__m64 numvec1_4	= _mm_set_pi16(113, 127, 131, 137);
__m64 numvec2_4	= _mm_set_pi16(112, 126, 130, 136);

__m64 zerovec	= _mm_set_pi16(0, 0, 0, 0);

_mm_empty();
     
#include "MAKES-boinc.H"

#if (REPORT_FREQUENCY==7)
for(i31=START_ITER;i31<7;++i31)
{
  /* There are 7 combinations of i31 that reach this block */
  checkpoint(SHIFT,K,i31,0);

#else
for(i31=0;i31<7;++i31)
#endif

for(i37=0;i37<13;++i37)
if(i37-i31<=10&&i31-i37<=4)
#if (REPORT_FREQUENCY==85)
{
  /* There are 85 combinations of i31,i37 that reach this block */
  if (iter++ < START_ITER)
    continue;

  checkpoint(SHIFT,K,iter-1,0);

#endif

for(i41=0;i41<17;++i41)
if(i41-i31<=14&&i41-i37<=14&&i31-i41<=4&&i37-i41<=10)
#if (REPORT_FREQUENCY==1355)
{
  /* There are 1355 combinations of i31,i37,i41 that reach this block */
  if (iter++ < START_ITER)
    continue;
  checkpoint(SHIFT,K,iter-1,0);

#endif

for(i3=0;i3<2;++i3)
for(i5=0;i5<4;++i5)
{ 

n43=(n0+i3*S3+i5*S5+i31*S31+i37*S37+i41*S41)%MOD;


{

for(i43=(PRIME5-24);i43>0;i43--)
{

n47=n43;
for(i47=(PRIME6-24);i47>0;i47--)
{

n53=n47;
for(i53=(PRIME7-24);i53>0;i53--)
{

n59=n53;

// 32-bit
int n59a = n59&((1<<30)-1);
int n59b = n59>>30;

// Bryan Little, new fast vectors for loop
__m64 r_numvec1 = _mm_set_pi16((n59a+60*n59b)%61, (n59a+25*n59b)%67, (n59a+20*n59b)%71, (n59a+8*n59b)%73);
__m64 r_numvec2 = _mm_set_pi16((n59a+52*n59b)%79, (n59a+40*n59b)%83, (n59a+78*n59b)%89, (n59a+33*n59b)%97);
__m64 r_numvec3 = _mm_set_pi16((n59a+17*n59b)%101, (n59a+93*n59b)%103, (n59a+34*n59b)%107, (n59a+46*n59b)%109);
__m64 r_numvec4 = _mm_set_pi16((n59a+4*n59b)%113, (n59a+4*n59b)%127, (n59a+62*n59b)%131, (n59a+77*n59b)%137);


for(i59=(PRIME8-24);i59>0;i59--)
{

#include "SITO-boinc-SSE.H"
{
int b;

_mm_empty();

for(b=0;b<64;b++)
if((sito>>b)&1)
{

#if IF32
int na, nb, nc, tmp1, tmp2;
#endif

n=n59+(b+SHIFT)*MOD;

// 32-bit
#include "if32/IF32.H"
{

	int64_t m;
	int k;
	k=0; m=n+STEP*5;
	while(PrimeQ(m)){
		k++;
		m+=STEP;
	}


	if(k>=10){
		m=n+STEP*4;
		while(m>0&&PrimeQ(m)){
			k++;
			m-=STEP;
		}
	}



	if(k>=10){
		ReportSolution(k,K,m+STEP);
	}
} //if

} //for

} //sito

// Bryan Little - new fast vector math
if(i59>1){
	n59+=S59;

	//vector 1
	r_numvec1 = _mm_adds_pi16(r_numvec1, svec1);
	//vector 2
	r_numvec2 = _mm_adds_pi16(r_numvec2, svec2);
	//vector 3
	r_numvec3 = _mm_adds_pi16(r_numvec3, svec3);
	//vector 4
	r_numvec4 = _mm_adds_pi16(r_numvec4, svec4);

	if(n59>=MOD){
		n59-=MOD;
		
		//vector 1
		r_numvec1 = _mm_subs_pi16(r_numvec1, mvec1);
		r_numvec1 = vec_sel64(r_numvec1, _mm_adds_pi16(r_numvec1, numvec1_1), _mm_cmpgt_pi16( zerovec, r_numvec1 ) );
		//vector 2
		r_numvec2 = _mm_subs_pi16(r_numvec2, mvec2);
		r_numvec2 = vec_sel64(r_numvec2, _mm_adds_pi16(r_numvec2, numvec1_2), _mm_cmpgt_pi16( zerovec, r_numvec2 ) );
		//vector 3
		r_numvec3 = _mm_subs_pi16(r_numvec3, mvec3);
		r_numvec3 = vec_sel64(r_numvec3, _mm_adds_pi16(r_numvec3, numvec1_3), _mm_cmpgt_pi16( zerovec, r_numvec3 ) );
		//vector 4
		r_numvec4 = _mm_subs_pi16(r_numvec4, mvec4);
		r_numvec4 = vec_sel64(r_numvec4, _mm_adds_pi16(r_numvec4, numvec1_4), _mm_cmpgt_pi16( zerovec, r_numvec4 ) );
	}
	//vector 1
	r_numvec1 = vec_sel64(r_numvec1, _mm_subs_pi16(r_numvec1, numvec1_1), _mm_cmpgt_pi16(r_numvec1, numvec2_1) );
	//vector 2
	r_numvec2 = vec_sel64(r_numvec2, _mm_subs_pi16(r_numvec2, numvec1_2), _mm_cmpgt_pi16(r_numvec2, numvec2_2) );
	//vector 3
	r_numvec3 = vec_sel64(r_numvec3, _mm_subs_pi16(r_numvec3, numvec1_3), _mm_cmpgt_pi16(r_numvec3, numvec2_3) );
	//vector 4
	r_numvec4 = vec_sel64(r_numvec4, _mm_subs_pi16(r_numvec4, numvec1_4), _mm_cmpgt_pi16(r_numvec4, numvec2_4) );
} //end new fast vector math


} // end for(i59=(PRIME8-24);i59>0;i59--)

_mm_empty();

n53+=S53;
if(n53>=MOD)n53-=MOD;
}  // end for(i53=(PRIME7-24);i53>0;i53--)

n47+=S47;
if(n47>=MOD)n47-=MOD;
}

n43+=S43;
if(n43>=MOD)n43-=MOD;
}
};


}
#if (REPORT_FREQUENCY==1355)
}
#endif
#if (REPORT_FREQUENCY==85)
}
#endif
#if (REPORT_FREQUENCY==7)
}
#endif

}


