// *************************************************************************** sse2
// *************************************************************************** sse2
// *************************************************************************** sse2
// *************************************************************************** sse2

__m128i vec_sel( __m128i a, __m128i b, __m128i mask ){

        b = _mm_and_si128( b, mask );
        a = _mm_andnot_si128( mask, a );

        return _mm_or_si128( a, b );
}


void SearchAP26_SSE2(int K, int SHIFT, int START_ITER)
{ 
int64_t n, n43, n47, n53, n59;
int i43, i47, i53, i59;
int i3, i5, i31, i37, i41;

int j, jj;

int64_t STEP;
int64_t n0;
int64_t sito;
int64_t S31, S37, S41, S43, S47, S53, S59;

#if (REPORT_FREQUENCY==85 || REPORT_FREQUENCY==1355)
int iter = 0;
#endif

STEP=K*PRIM23;
n0=(N0*(K%17835)+((N0*17835)%MOD)*(K/17835)+N30)%MOD;

S31=(PRES2*(K%17835)+((PRES2*17835)%MOD)*(K/17835))%MOD;
S37=(PRES3*(K%17835)+((PRES3*17835)%MOD)*(K/17835))%MOD;
S41=(PRES4*(K%17835)+((PRES4*17835)%MOD)*(K/17835))%MOD;
S43=(PRES5*(K%17835)+((PRES5*17835)%MOD)*(K/17835))%MOD;
S47=(PRES6*(K%17835)+((PRES6*17835)%MOD)*(K/17835))%MOD;
S53=(PRES7*(K%17835)+((PRES7*17835)%MOD)*(K/17835))%MOD;
S59=(PRES8*(K%17835)+((PRES8*17835)%MOD)*(K/17835))%MOD;

//quick loop vectors
__m128i svec1		= _mm_set_epi16(S59%61, S59%67, S59%71, S59%73, S59%79, S59%83, S59%89, S59%97);
__m128i svec2		= _mm_set_epi16(S59%101, S59%103, S59%107, S59%109, S59%113, S59%127, S59%131, S59%137);

__m128i mvec1		= _mm_set_epi16(MOD%61, MOD%67, MOD%71, MOD%73, MOD%79, MOD%83, MOD%89, MOD%97);
__m128i mvec2		= _mm_set_epi16(MOD%101, MOD%103, MOD%107, MOD%109, MOD%113, MOD%127, MOD%131, MOD%137);

__m128i numvec1_1	= _mm_set_epi16(61, 67, 71, 73, 79, 83, 89, 97);
__m128i numvec2_1	= _mm_set_epi16(60, 66, 70, 72, 78, 82, 88, 96);

__m128i numvec1_2	= _mm_set_epi16(101, 103, 107, 109, 113, 127, 131, 137);
__m128i numvec2_2	= _mm_set_epi16(100, 102, 106, 108, 112, 126, 130, 136);

__m128i zerovec	= _mm_set_epi16(0, 0, 0, 0, 0, 0, 0, 0);

                    
       
#include "MAKES-boinc.H"

#if (REPORT_FREQUENCY==7)
for(i31=START_ITER;i31<7;++i31)
{
  /* There are 7 combinations of i31 that reach this block */
  checkpoint(SHIFT,K,i31,0);

#else
for(i31=0;i31<7;++i31)
#endif

for(i37=0;i37<13;++i37)
if(i37-i31<=10&&i31-i37<=4)
#if (REPORT_FREQUENCY==85)
{
  /* There are 85 combinations of i31,i37 that reach this block */
  if (iter++ < START_ITER)
    continue;
  checkpoint(SHIFT,K,iter-1,0);

#endif

for(i41=0;i41<17;++i41)
if(i41-i31<=14&&i41-i37<=14&&i31-i41<=4&&i37-i41<=10)
#if (REPORT_FREQUENCY==1355)
{
  /* There are 1355 combinations of i31,i37,i41 that reach this block */
  if (iter++ < START_ITER)
    continue;
  checkpoint(SHIFT,K,iter-1,0);

#endif

for(i3=0;i3<2;++i3)
for(i5=0;i5<4;++i5)
{ 




n43=(n0+i3*S3+i5*S5+i31*S31+i37*S37+i41*S41)%MOD;
{

for(i43=(PRIME5-24);i43>0;i43--)
{

n47=n43;
for(i47=(PRIME6-24);i47>0;i47--)
{

n53=n47;
for(i53=(PRIME7-24);i53>0;i53--)
{

n59=n53;

// Bryan Little, new fast vectors for loop
// integers are stored IN REVERSE ORDER in SSE2!

// 32-bit
int n59a=n59&((1<<30)-1);
int n59b=n59>>30;

__m128i r_numvec1 = _mm_set_epi16((n59a+60*n59b)%61, (n59a+25*n59b)%67, (n59a+20*n59b)%71, (n59a+8*n59b)%73, (n59a+52*n59b)%79, (n59a+40*n59b)%83, (n59a+78*n59b)%89, (n59a+33*n59b)%97);

__m128i r_numvec2 = _mm_set_epi16((n59a+17*n59b)%101, (n59a+93*n59b)%103, (n59a+34*n59b)%107, (n59a+46*n59b)%109, (n59a+4*n59b)%113, (n59a+4*n59b)%127, (n59a+62*n59b)%131, (n59a+77*n59b)%137);


for(i59=(PRIME8-24);i59>0;i59--)
{

#include "SITO-boinc-SSE2.H"
{
int b;

for(b=0;b<64;b++)
if((sito>>b)&1)
{

#if IF32
int na, nb, nc, tmp1, tmp2;
#endif

n=n59+(b+SHIFT)*MOD;

// 32-bit
#include "if32/IF32.H"
{
int64_t m;
int k;
k=0; m=n+STEP*5;
while(PrimeQ(m)){
k++;
m+=STEP;
};


if(k>=10){
m=n+STEP*4;
while(m>0&&PrimeQ(m)){
k++;
m-=STEP;
};
};



if(k>=10)
{
ReportSolution(k,K,m+STEP);
};
};

}

}

// Bryan Little - new fast vector math
if(i59>1){
	n59+=S59;

	//vector 1
	r_numvec1 = _mm_add_epi16(r_numvec1, svec1);
	//vector 2
	r_numvec2 = _mm_add_epi16(r_numvec2, svec2);

	if(n59>=MOD){
		n59-=MOD;

		//vector 1
		r_numvec1 = _mm_sub_epi16(r_numvec1, mvec1);
		r_numvec1 = vec_sel( r_numvec1, _mm_add_epi16(r_numvec1, numvec1_1), _mm_cmpgt_epi16( zerovec, r_numvec1 ) );
		//vector 2
		r_numvec2 = _mm_sub_epi16(r_numvec2, mvec2);
		r_numvec2 = vec_sel(r_numvec2, _mm_add_epi16(r_numvec2, numvec1_2), _mm_cmpgt_epi16( zerovec, r_numvec2 ) );
	}
	//vector 1
	r_numvec1 = vec_sel(r_numvec1, _mm_sub_epi16(r_numvec1, numvec1_1), _mm_cmpgt_epi16(r_numvec1, numvec2_1) );
	//vector 2
	r_numvec2 = vec_sel(r_numvec2, _mm_sub_epi16(r_numvec2, numvec1_2), _mm_cmpgt_epi16(r_numvec2, numvec2_2) );
} //end new fast vector math

           
}               

n53+=S53;
if(n53>=MOD)n53-=MOD;
}

n47+=S47;
if(n47>=MOD)n47-=MOD;
}

n43+=S43;
if(n43>=MOD)n43-=MOD;
}
};


}
#if (REPORT_FREQUENCY==1355)
}
#endif
#if (REPORT_FREQUENCY==85)
}
#endif
#if (REPORT_FREQUENCY==7)
}
#endif
#if 0
}
#endif
#if ASM
asm_fini();
#endif
}
