/* AP26-boinc.h --

   This file is a replacement for AP26.h in Jaroslaw Wroblewski's AP26
   sample implementation. Most of my changes are between #if REPORT_FREQUENCY
   #endif clauses, they exist only to allow the program to checkpoint part
   way through the SearchAP26(K,SHIFT) routine. Other minor changes are to
   use int64_t instead of long long for compilers that don't conform to C99.

   See http://www.geocities.com/g_w_reynolds/AP26/AP26-boinc-src.zip for the
   latest version of this file.

   See http://www.math.uni.wroc.pl/~jwr/AP26/AP26.zip for the sample
   implementation containing the rest of the source required.

   See http://www.math.uni.wroc.pl/~jwr/AP26/AP26v3.pdf for information
   about how the algorithm works and for the copyleft notice.
*/


#if ASM
# include "asm.h"
#endif

#include "CONST-boinc.H"


#if (REPORT_FREQUENCY > 1)
void SearchAP26(int K, int SHIFT, int START_ITER)
#else
void SearchAP26(int K, int SHIFT)
#endif
{ 
int64_t n, n43, n47, n53, n59;
int i43, i47, i53, i59;
int i3, i5, i31, i37, i41;

int j, jj;

int64_t STEP;
#if 0
int64_t STEP5;
int64_t STEP4;
#endif
int64_t n0;
int64_t sito;



int64_t S31, S37, S41, S43, S47, S53, S59;

int s61, s67, s71, s73, s79, s83, s89, s97;
#if 0
int m61, m67, m71, m73, m79, m83, m89, m97;
#endif

#if (REPORT_FREQUENCY==85 || REPORT_FREQUENCY==1355)
int iter = 0;
#endif

#if 0
if(
		K%PRIME1&&
		K%PRIME2&&
		K%PRIME3&&
		K%PRIME4&&
		K%PRIME5&&
		K%PRIME6&&
		K%PRIME7&&
		K%PRIME8
     )
{
#endif

STEP=K*PRIM23;
#if 0
STEP4=STEP*4;
STEP5=STEP*5;
#endif
n0=(N0*(K%17835)+((N0*17835)%MOD)*(K/17835)+N30)%MOD;


S31=(PRES2*(K%17835)+((PRES2*17835)%MOD)*(K/17835))%MOD;
S37=(PRES3*(K%17835)+((PRES3*17835)%MOD)*(K/17835))%MOD;
S41=(PRES4*(K%17835)+((PRES4*17835)%MOD)*(K/17835))%MOD;
S43=(PRES5*(K%17835)+((PRES5*17835)%MOD)*(K/17835))%MOD;
S47=(PRES6*(K%17835)+((PRES6*17835)%MOD)*(K/17835))%MOD;
S53=(PRES7*(K%17835)+((PRES7*17835)%MOD)*(K/17835))%MOD;
S59=(PRES8*(K%17835)+((PRES8*17835)%MOD)*(K/17835))%MOD;
                        
s61=S59%61;
s67=S59%67;
s71=S59%71;
s73=S59%73;
s79=S59%79;
s83=S59%83;
s89=S59%89;
s97=S59%97;

#if 0
m61=MOD%61;
m67=MOD%67;
m71=MOD%71;
m73=MOD%73;
m79=MOD%79;
m83=MOD%83;
m89=MOD%89;
m97=MOD%97;
#endif
        
#include "MAKES-boinc.H"

#if ASM
 asm_init();
#endif

#if (REPORT_FREQUENCY==7)
for(i31=START_ITER;i31<7;++i31)
{
  /* There are 7 combinations of i31 that reach this block */
  checkpoint(SHIFT,K,i31,0);

#else
for(i31=0;i31<7;++i31)
#endif

for(i37=0;i37<13;++i37)
if(i37-i31<=10&&i31-i37<=4)
#if (REPORT_FREQUENCY==85)
{
  /* There are 85 combinations of i31,i37 that reach this block */
  if (iter++ < START_ITER)
    continue;
  checkpoint(SHIFT,K,iter-1,0);

#endif

for(i41=0;i41<17;++i41)
if(i41-i31<=14&&i41-i37<=14&&i31-i41<=4&&i37-i41<=10)
#if (REPORT_FREQUENCY==1355)
{
  /* There are 1355 combinations of i31,i37,i41 that reach this block */
  if (iter++ < START_ITER)
    continue;
  checkpoint(SHIFT,K,iter-1,0);

#endif

for(i3=0;i3<2;++i3)
for(i5=0;i5<4;++i5)
{ 




n43=(n0+i3*S3+i5*S5+i31*S31+i37*S37+i41*S41)%MOD;
{

for(i43=(PRIME5-24);i43>0;i43--)
{

n47=n43;
for(i47=(PRIME6-24);i47>0;i47--)
{

n53=n47;
for(i53=(PRIME7-24);i53>0;i53--)
{
int r61, r67, r71, r73, r79, r83, r89, r97;

#if FASTER32
 int n59a, n59b;
#endif

n59=n53;

#if FASTER32
# include "faster32/rep32-1a.h"
#else
r61=REM(n59,61,6);
r67=REM(n59,67,7);
r71=REM(n59,71,7);
r73=REM(n59,73,7);
r79=REM(n59,79,7);
r83=REM(n59,83,7);
r89=REM(n59,89,7);
r97=REM(n59,97,7);
#endif

for(i59=(PRIME8-24);i59>0;i59--)
{

#include "SITO-boinc.H"
{
int b;

for(b=0;b<64;b++)
if((sito>>b)&1)

{
#if IF32
int na, nb, nc, tmp1, tmp2;
#endif

n=n59+(b+SHIFT)*MOD;

#if IF32
#include "if32/IF32.H"
#else
if(n%7)
if(n%11)
if(n%13)
if(n%17)
if(n%19)
if(n%23)
#include "AP26/IF.H"
#endif
{
int64_t m;
int k;
#if 0
k=0; m=n+STEP5;
#else
k=0; m=n+STEP*5;
#endif
while(PrimeQ(m)){
k++;
m+=STEP;
};


if(k>=10){
#if 0
m=n+STEP4;
#else
m=n+STEP*4;
#endif
while(m>0&&PrimeQ(m)){
k++;
m-=STEP;
};
};



if(k>=10)
{
ReportSolution(k,K,m+STEP);
};
};

}

}
if(i59>1){
n59+=S59;
r61+=s61;
r67+=s67;
r71+=s71;
r73+=s73;
r79+=s79;
r83+=s83;
r89+=s89;
r97+=s97;
if(n59>=MOD){
n59-=MOD;
#if 0
r61-=m61;
r67-=m67;
r71-=m71;
r73-=m73;
r79-=m79;
r83-=m83;
r89-=m89;
r97-=m97;
#else
r61-=(MOD%61);
r67-=(MOD%67);
r71-=(MOD%71);
r73-=(MOD%73);
r79-=(MOD%79);
r83-=(MOD%83);
r89-=(MOD%89);
r97-=(MOD%97);
#endif
if(r61<0)r61+=61;
if(r67<0)r67+=67;
if(r71<0)r71+=71;
if(r73<0)r73+=73;
if(r79<0)r79+=79;
if(r83<0)r83+=83;
if(r89<0)r89+=89;
if(r97<0)r97+=97;
};
if(r61>=61)r61-=61;            
if(r67>=67)r67-=67;            
if(r71>=71)r71-=71;            
if(r73>=73)r73-=73;            
if(r79>=79)r79-=79;            
if(r83>=83)r83-=83;            
if(r89>=89)r89-=89;            
if(r97>=97)r97-=97; 
}           
}               

n53+=S53;
if(n53>=MOD)n53-=MOD;
}

n47+=S47;
if(n47>=MOD)n47-=MOD;
}

n43+=S43;
if(n43>=MOD)n43-=MOD;
}
};


}
#if (REPORT_FREQUENCY==1355)
}
#endif
#if (REPORT_FREQUENCY==85)
}
#endif
#if (REPORT_FREQUENCY==7)
}
#endif
#if 0
}
#endif
#if ASM
asm_fini();
#endif
}
