/* This file replaces SITO.H from Jaroslaw Wroblewski's AP26 sample
   implementation. Changes are contained between the __GNUC__ and FASTER32
   conditionals.

   For GCC, __builtin_expect(EXP,C) means that EXP is predicted to evaluate
   to C. Other compilers will surely have a different way to do this, and so
   it is only used when __GNUC__ is defined.
*/

#ifdef __GNUC__
# define UNLIKELY(_EXP) __builtin_expect((_EXP)!=0,0)
#else
# define UNLIKELY(_EXP) (_EXP)
#endif

if(UNLIKELY(sito = OKOK61[r61]
                 & OKOK67[r67]
                 & OKOK71[r71]
                 & OKOK73[r73]
                 & OKOK79[r79]
                 & OKOK83[r83]
                 & OKOK89[r89]
                 & OKOK97[r97]))

#if ASM
if (UNLIKELY(sito = sito_mask(sito,n59)))

#elif FASTER32
# include "faster32/rep32-2a.h"

#else
if(UNLIKELY(sito&=(OKOK101[REM(n59,101,7)]
                 & OKOK103[REM(n59,103,7)]
                 & OKOK107[REM(n59,107,7)]
                 & OKOK109[REM(n59,109,7)]
                 & OKOK113[REM(n59,113,7)]
                 & OKOK127[REM(n59,127,7)]
                 & OKOK131[REM(n59,131,8)]
                 & OKOK137[REM(n59,137,8)]
                 & OKOK139[REM(n59,139,8)])))
if(UNLIKELY(sito&=(OKOK149[REM(n59,149,8)]
                 & OKOK151[REM(n59,151,8)]
                 & OKOK157[REM(n59,157,8)]
                 & OKOK163[REM(n59,163,8)]
                 & OKOK167[REM(n59,167,8)]
                 & OKOK173[REM(n59,173,8)]
                 & OKOK179[REM(n59,179,8)]
                 & OKOK181[REM(n59,181,8)]
                 & OKOK191[REM(n59,191,8)]
                 & OKOK193[REM(n59,193,8)])))
if(UNLIKELY(sito&=(OKOK197[REM(n59,197,8)]
                 & OKOK199[REM(n59,199,8)]
                 & OKOK211[REM(n59,211,8)]
                 & OKOK223[REM(n59,223,8)]
                 & OKOK227[REM(n59,227,8)]
                 & OKOK229[REM(n59,229,8)]
                 & OKOK233[REM(n59,233,8)]
                 & OKOK239[REM(n59,239,8)]
                 & OKOK241[REM(n59,241,8)]
                 & OKOK251[REM(n59,251,8)]
                 & OKOK257[REM(n59,257,9)])))
if(UNLIKELY(sito&=(OKOK263[REM(n59,263,9)]
                 & OKOK269[REM(n59,269,9)]
                 & OKOK271[REM(n59,271,9)]
                 & OKOK277[REM(n59,277,9)]
                 & OKOK281[REM(n59,281,9)]
                 & OKOK283[REM(n59,283,9)]
                 & OKOK293[REM(n59,293,9)]
                 & OKOK307[REM(n59,307,9)]
                 & OKOK311[REM(n59,311,9)]
                 & OKOK313[REM(n59,313,9)]
                 & OKOK317[REM(n59,317,9)]
                 & OKOK331[REM(n59,331,9)])))
#endif
